Imports GrapeCity.ActiveReports

Public Class SectionReport3
    Private paperSize As GrapeCity.ActiveReports.Printing.PaperSize
    Private contentHeight As Single = -1
    Private detailsHeight As Single = 0
    Private pageHeaderHeight As Single = 0
    Private pageFooterHeight As Single = 0

    Private Sub SectionReport3_ReportStart(sender As System.Object, e As System.EventArgs) Handles MyBase.ReportStart

        If contentHeight = -1 Then
            Dim rptForCalculation As New SectionReport3()
            rptForCalculation.contentHeight = 0
            rptForCalculation.Run()
            contentHeight = rptForCalculation.contentHeight

            paperSize = New Printing.PaperSize(Printing.PaperKind.Custom, (Me.PrintWidth + Me.PageSettings.Margins.Left + Me.PageSettings.Margins.Right) * 100, (contentHeight + Me.PageSettings.Margins.Top + Me.PageSettings.Margins.Bottom) * 100)

            Me.Document.Printer.PaperSize = paperSize

        End If
    End Sub

    Private Sub SectionReport3_ReportEnd(sender As Object, e As EventArgs) Handles MyBase.ReportEnd
        If contentHeight = 0 Then
            contentHeight = detailsHeight + pageHeaderHeight + pageFooterHeight
        End If
    End Sub

    Private Sub Detail1_AfterPrint(sender As Object, e As EventArgs) Handles Detail1.AfterPrint
        detailsHeight = detailsHeight + Me.Detail1.Height
    End Sub

    Private Sub PageHeader1_AfterPrint(sender As Object, e As EventArgs) Handles PageHeader1.AfterPrint
        If pageHeaderHeight = 0 Then
            pageHeaderHeight = Me.PageHeader1.Height
        End If
    End Sub

    Private Sub PageFooter1_AfterPrint(sender As Object, e As EventArgs) Handles PageFooter1.AfterPrint
        If pageFooterHeight = 0 Then
            pageFooterHeight = Me.PageFooter1.Height
        End If
    End Sub
End Class
